<template>
  <div class="sw-gs-layer-product-actions" :class="{'is-overlay': overlay}" @click="(e) =>  e.stopPropagation()">
    <SwPluginSlot name="gs-layer-product-actions-before"></SwPluginSlot>

    <div class="sw-gs-layer-product-actions-start">
      <SwButton v-if="detailLink"
                class="sw-gs-layer-product-action is-action-detail color-transparent is-small"
                :title="$t('Go to product detail page')"
                @click="goToDetailClick()">
        <SwGsIconLongArrowRight class="color-secondary-primary size-xs"/>
      </SwButton>

      <SwButton v-if="instantListingModalType === instantListingTypes[0]" class="sw-gs-layer-product-action sw-gs-layer-guide-product-like-toggle color-transparent is-small"
                :title="productOnGuideList ? $t('Remove from guide product list') : $t('Add to guide product list')"
                :disabled="toggleLikeLoading"
                @click.stop="toggleGuideLike">
        <SfLoader :loading="toggleLikeLoading" class="sw-gs-layer-product-actions-loader">
          <SwGsIconBookmarkOn v-if="productOnGuideList"
                              class="color-secondary-primary size-xs is-on-list"/>
          <SwGsIconBookmarkOff v-else
                               class="color-secondary-primary size-xs"/>
        </SfLoader>
      </SwButton>

      <div>
        <SwGsAddToCartBtn v-if="currentClientCartPermissions" class="sw-gs-layer-product-action is-action-cart" :product="product"/>
      </div>
    </div>

    <div class="sw-gs-layer-product-actions-end">
      <SwButton v-if="filterCount"
                class="sw-gs-layer-product-action is-action-filter color-transparent is-small" :title="$t('Filter')">
        <SwGsIconFilter class="color-secondary-primary size-xs"/>
        <span v-if="additionalInfos" class="sw-gs-layer-product-action-additional-infos">
          {{ filterCount }}
        </span>
      </SwButton>

      <SwButton class="sw-gs-layer-product-action is-action-likes color-transparent is-small" :title="$t('Likes')">
        <SwGsIconThumbsUpSmall class="color-secondary-primary size-sm"/>
        <SfLoader v-if="additionalInfos" :loading="likeAndDislikeLoading" class="sw-gs-layer-product-actions-loader">
          <span class="sw-gs-layer-product-action-additional-infos">
            {{ allProductLikesCount }}
          </span>
        </SfLoader>
      </SwButton>

      <SwButton class="sw-gs-layer-product-action is-action-dislikes color-transparent is-small" :title="$t('Dislikes')">
        <SwGsIconThumbsDownSmall class="color-secondary-primary size-sm"/>
        <SfLoader v-if="additionalInfos" :loading="likeAndDislikeLoading" class="sw-gs-layer-product-actions-loader">
          <span class="sw-gs-layer-product-action-additional-infos">
            {{ allProductDislikesCount }}
          </span>
        </SfLoader>
      </SwButton>
    </div>

    <SwPluginSlot name="gs-layer-product-actions-after"></SwPluginSlot>
  </div>
</template>

<script lang="ts">
  import {SfLoader} from "@storefront-ui/vue";
  import SwPluginSlot from "sw-plugins/SwPluginSlot.vue"
  import SwButton from "@/components/atoms/SwButton.vue";
  import {computed, toRefs, onMounted, ref} from "@vue/composition-api";
  import {
    SwGsIconCart,
    SwGsIconThumbsUpSmall,
    SwGsIconThumbsDownSmall,
    SwGsIconFilter,
    SwGsIconLongArrowRight,
    SwGsIconBookmarkOn,
    SwGsIconBookmarkOff
  } from "../icons";
  import {useDynamicPage} from "../../logic/composables/useDynamicPage";
  import {useLikeList} from "../../logic/composables/useLikeList";
  import SwGsAddToCartBtn from "../SwGsAddToCartBtn.vue";
  import {useGsCart} from "../../logic/composables/useGsCart";
  import {INSTANT_LISTING_TYPES, useInstantListing} from "../../logic/composables/useInstantListing";

  export default {
    name: "SwGsLayerProductActions",
    components: {
      SwGsIconBookmarkOn,
      SwGsIconBookmarkOff,
      SwPluginSlot,
      SwButton,
      SwGsIconCart,
      SwGsIconThumbsUpSmall,
      SwGsIconThumbsDownSmall,
      SwGsIconFilter,
      SwGsIconLongArrowRight,
      SfLoader,
      SwGsAddToCartBtn
    },
    props: {
      product: {
        type: Object,
        default: () => ({}),
      },
      overlay: {
        type: Boolean,
        default: false,
      },
      additionalInfos: {
        type: Boolean,
        default: false,
      },
      detailLink: {
        type: Boolean,
        default: true,
      },
      filterCount: {
        type: Number,
        default: null
      }
    },
    setup(props, {}) {
      const {product} = toRefs(props);
      const productId = computed(() => product?.value.id);
      const {openDynamicPage} = useDynamicPage();
      const {currentClientCartPermissions} = useGsCart();

      const {
        loadAllProductLikesAndDislikes,
        allProductLikesCount,
        allProductDislikesCount,
        productOnGuideList,
        toggleLikeLoading,
        toggleGuideLike,
        initLikeListForProductWidget
      } = useLikeList(product.value);
      const likeAndDislikeLoading = ref(false);

      initLikeListForProductWidget();

      const {
        isInstantListingModalOpen,
        instantListingModalType,
      } = useInstantListing();

      onMounted(async () => {
        if (!props.additionalInfos) return;
        likeAndDislikeLoading.value = true;
        await loadAllProductLikesAndDislikes();
        likeAndDislikeLoading.value = false;
      })

      const likeLoading = ref(false);

      function goToDetailClick() {
        isInstantListingModalOpen.value = false;

        openDynamicPage({
          type: 'product',
          opened: true,
          productId: productId.value
        })
      }

      return {
        toggleLikeLoading,
        toggleGuideLike,
        productId,
        instantListingModalType,
        instantListingTypes: INSTANT_LISTING_TYPES,
        openDynamicPage,
        likeAndDislikeLoading,
        allProductLikesCount,
        allProductDislikesCount,
        likeLoading,
        productOnGuideList,
        currentClientCartPermissions,
        goToDetailClick
      }

    }
  }
</script>

<style lang="scss" scoped>
  .sw-gs-layer-product-actions {
    display: flex;
    flex-flow: wrap;

    .sw-gs-layer-product-actions-start,
    .sw-gs-layer-product-actions-end {
      display: flex;
      width: 50%;
    }

    .sw-gs-layer-product-actions-start {
      justify-content: flex-start;
    }

    .sw-gs-layer-product-actions-end {
      justify-content: flex-end;
    }

    &,
    .sw-gs-layer-product-action {
      background: var(--c-light);

      &.is-action-likes {
        --icon-color: var(--c-success);

        .sw-gs-layer-product-action-additional-infos {
          color: var(--c-success);
        }
      }

      &.is-action-dislikes {
        --icon-color: var(--c-danger);

        .sw-gs-layer-product-action-additional-infos {
          color: var(--c-danger);
        }
      }
    }

    .sw-gs-layer-product-action {
      padding: var(--spacer-xs);

      &.sw-gs-layer-guide-product-like-toggle {
        .is-on-list {
          --icon-color: var(--c-success);
        }
      }

      &.sw-gs-add-to-cart-btn {
        display: block;
        opacity: 1;
        position: static;
        background: transparent;
        height: auto;
        width: auto;
        transform: none;
        padding: var(--spacer-xs);

        ::v-deep .sf-icon {
          --icon-color: var(--c-black);
          height: 16px;
          width: 16px;
        }
      }
    }

    &.is-overlay {
      display: flex;
      flex-flow: wrap;
      flex-direction: column;
      position: absolute;
      top: 0;
      left: 0;
      height: 100%;

      .sw-gs-layer-product-actions-start,
      .sw-gs-layer-product-actions-end {
        width: auto;
        height: 50%;
        flex-flow: wrap;
        flex-direction: column;
        align-content: center;
      }
    }

    ::v-deep .sf-button:hover {
      --button-box-shadow-opacity: 0;
    }
  }

  .sw-gs-layer-product-action-additional-infos {
    color: var(--c-text);
  }

  .sw-gs-layer-product-actions-loader {
    display: inline;
    min-width: 16px;
    min-height: 16px;
    width: auto;
    height: auto;

    .sf-loader__spinner {
      max-width: 15px;
      max-height: 15px;
    }

    .sf-loader__overlay {
      background: transparent;
    }
  }
</style>
